//==========================================================================
//
// csb360_gpio.h
//
//
// Author(s):    Michael Kelly, Cogent Computer Systems, Inc.
// Contributors: 
// Date:         03/03/03
// Description:  This file contains bit defines for the CSB360 GPIO's
//
//--------------------------------------------------------------------------


//--------------------------------------------------------------------------
// GPIO assignments for the CSB360 are as follows.
// Active indicates what level is considered active for that
// signal, if any.  A/F indicates alternate function mode (0 = none).
//
// GPIO		Direction	Active	A/F	Description
// Port A		Logical	Bit	   Direction	Active	Description
#define GPIO_SD_CD		0	// In	 		Low		SD Card Detect Switch
#define GPIO_SD_WP		1	// In	 		Low		SD Card Write Protect Switch
#define GPIO_PA2		2	// In			N/A		Expansion Connector Pin 19
#define GPIO_LED0		3	// Out			Low		User LED 0
#define GPIO_LED1		4	// Out			Low		User LED 1
#define GPIO_LED2		5	// Out			Low		User LED 2
#define GPIO_PA6		6	// In			N/A		Expansion Connector Pin 9
#define GPIO_PA7		7	// In			N/A		Expansion Connector Pin 10
#define GPIO_PA8		8	// In			N/A		Expansion Connector Pin 11
#define GPIO_PA9		9	// In			N/A		Expansion Connector Pin 12
#define GPIO_PA10		10	// In			N/A		Expansion Connector Pin 13
							// PA11 is assigned to QSPI Chip Select 1 - Expansion Connector
#define GPIO_PA12		12	// In			N/A		Expansion Connector Pin 14
#define GPIO_PA13		13	// In			N/A		Expansion Connector Pin 15
#define GPIO_PA14		14	// In			N/A		Expansion Connector Pin 16
#define GPIO_PA15		15	// In			Low		User Pushbutton Switch 1 (also Interrupt 6)

// Port B		Logical	Bit	   Direction	Active	Description
							// PB0 is assigned to UART 0 TXD
							// PB1 is assigned to UART 0 RXD
							// PB2 is assigned to UART 0 CTS
							// PB3 is assigned to UART 0 RTS
							// PB4 is assigned to UART 0 Baud Clock
							// PB5 is assigned to *TA
#define GPIO_SCL		22	// Out	 		N/A		I2C Clock Line
#define GPIO_SDA		23	// N/A	 		N/A		I2C Data Line
							// PB8 is assigned to Ethernet TXD3
							// PB9 is assigned to Ethernet TXD2
							// PB10 is assigned to Ethernet TXD1
							// PB11 is assigned to Ethernet RXD3
							// PB12 is assigned to Ethernet RXD2
							// PB13 is assigned to Ethernet RXD1
							// PB14 is assigned to Ethernet RXERR
							// PB15 is assigned to Ethernet MDC


