/* mmc.h:
 *	This file contains the portions of the flash code that are device
 *	independent.  Refer to the appropriate device sub-directory for the
 *	code that is specific to the flash device on the target.
 *
 *	General notice:
 *	This code is part of a boot-monitor package developed as a generic base
 *	platform for embedded system designs.  As such, it is likely to be
 *	distributed to various projects beyond the control of the original
 *	author.  Please notify the author of any enhancements made or bugs found
 *	so that all may benefit from the changes.  In addition, notification back
 *	to the author will allow the new user to pick up changes that may have
 *	been made by other users after this version of the code was distributed.
 *
 *	Note1: the majority of this code was edited with 4-space tabs.
 *	Note2: as more and more contributions are accepted, the term "author"
 *		   is becoming a mis-representation of credit.
 *
 *	Original author:	David de la Cruz
 *	Email:				ddlc@techresc.net
 *
 *	Technology Rescue History:
 *	Version 2.1 :
 *		26.04.2004 : new module.
 */

#ifndef _mmc_h_
#define _mmc_h_

int MmcInit(int verbose);
int MmcRead(uchar *dst, ulong src, int size);
int MmcWrite(ulong dst, uchar *src, int size);


#endif	// _mmc_h_
