/* version.h:
 * Header file for Command Line Interface related stuff.
 *
 *	General notice:
 *	This code is part of a boot-monitor package developed as a generic base
 *	platform for embedded system designs.  As such, it is likely to be
 *	distributed to various projects beyond the control of the original
 *	author.  Please notify the author of any enhancements made or bugs found
 *	so that all may benefit from the changes.  In addition, notification back
 *	to the author will allow the new user to pick up changes that may have
 *	been made by other users after this version of the code was distributed.
 *
 *	Note1: the majority of this code was edited with 4-space tabs.
 *	Note2: as more and more contributions are accepted, the term "author"
 *		   is becoming a mis-representation of credit.
 *
 *	Original author:	David de la Cruz from Technology Rescue.
 *	Email:				ddlc@techresc.net
 */
#ifndef _boardver_h
#define _boardver_h


#ifdef __cplusplus
extern "C" {
#endif


#ifdef __cplusplus
}
#endif

// Define version sub number.
// History of version :
//	Version 1.0 : first umon version used by Technology Rescue. (P01 and N02 Technology Rescue boards, supporting Datalight Flash FX).
//	Version 2.0 : second version used by T.R. : used to boot windows CE .NET, including *.nb0 file support into TFS.
//	Version 2.1 : same umon core as version 2.0 but including this UMON_VERSION definition.

//	Sub version is used to clarify version of board binary.
//	It may be DEVELOPMENT, DEBUG or RELEASE version.
#define VER_DEVELOP	"DEVELOPMENT"
#define	VER_DEBUG	"DEBUG"
#define VER_RELEASE	"RELEASE"

// Note about UMON_VERSION:
//	This macro is used to define USR_HEADER1 macro in info.h. 
//	USR_HEADER1 is generated along with BUILDTIME and BUILDDATE macros.
#ifndef UMON_SUB_VERSION
#define UMON_SUB_VERSION	VER_DEVELOP
#endif

#endif //_boardver_h
