    .file "prelinux.S"

#define C1_DC		(1<<2)		/* dcache off/on */
#define C1_IC		(1<<12)		/* icache off/on */

.global _start
_start:
	stmfd	r13!, {r0-r12, r14}
 	mrc	p15, 0, r3, cr1, cr0, 0  /* turn off I/D-cache */
 	bic	r3, r3, #4096	/* 0x1000  ~(C1_DC | C1_IC); */
 	bic	r3, r3, #4	/* 0x4 */
 	mcr	p15, 0, r3, cr1, cr0, 0
	
 	mov	r0, #0
	mcr	p15, 0, r0, cr7, cr5, 0  /* arm_cache_flush */

 	mrc	p15, 0, r0, cr1, cr0, 1  /* l2cache_disable */
 	bic	r0, r0, #2
 	mcr	p15, 0, r0, cr1, cr0, 1

 	mov	r0, #1
	mrc	p15, 1, r0, cr0, cr0, 1  /* emu_ext_boot_l2_inv */
	

/*  START  taken from Linux arch/arm/boot/compressed/head.S
 *	__armv7_mmu_cache_flush() */
__armv7_mmu_cache_flush:
		mrc	p15, 0, r10, c0, c1, 5	@ read ID_MMFR1
		tst	r10, #0xf << 16		@ hierarchical cache (ARMv7)
		mov	r10, #0
		beq	hierarchical
		mcr	p15, 0, r10, c7, c14, 0	@ clean+invalidate D
		b	iflush
hierarchical:
		mcr	p15, 0, r10, c7, c10, 5	@ DMB
		stmfd	sp!, {r0-r5, r7, r9, r11}
		mrc	p15, 1, r0, c0, c0, 1	@ read clidr
		ands	r3, r0, #0x7000000	@ extract loc from clidr
		mov	r3, r3, lsr #23		@ left align loc bit field
		beq	finished		@ if loc is 0, then no need to clean
		mov	r10, #0			@ start clean at cache level 0
loop1:
		add	r2, r10, r10, lsr #1	@ work out 3x current cache level
		mov	r1, r0, lsr r2		@ extract cache type bits from clidr
		and	r1, r1, #7		@ mask of the bits for current cache only
		cmp	r1, #2			@ see what cache we have at this level
		blt	skip			@ skip if no cache, or just i-cache
		mcr	p15, 2, r10, c0, c0, 0	@ select current cache level in cssr
		mcr	p15, 0, r10, c7, c5, 4	@ isb to sych the new cssr&csidr
		mrc	p15, 1, r1, c0, c0, 0	@ read the new csidr
		and	r2, r1, #7		@ extract the length of the cache lines
		add	r2, r2, #4		@ add 4 (line length offset)
		ldr	r4, =0x3ff
		ands	r4, r4, r1, lsr #3	@ find maximum number on the way size
		clz	r5, r4			@ find bit position of way size increment
		ldr	r7, =0x7fff
		ands	r7, r7, r1, lsr #13	@ extract max number of the index size
loop2:
		mov	r9, r4			@ create working copy of max way size
loop3:
		orr	r11, r10, r9, lsl r5	@ factor way and cache number into r11
		orr	r11, r11, r7, lsl r2	@ factor index number into r11
		mcr	p15, 0, r11, c7, c14, 2	@ clean & invalidate by set/way
		subs	r9, r9, #1		@ decrement the way
		bge	loop3
		subs	r7, r7, #1		@ decrement the index
		bge	loop2
skip:
		add	r10, r10, #2		@ increment cache number
		cmp	r3, r10
		bgt	loop1
finished:
		ldmfd	sp!, {r0-r5, r7, r9, r11}
		mov	r10, #0			@ swith back to cache level 0
		mcr	p15, 2, r10, c0, c0, 0	@ select current cache level in cssr
iflush:
		mcr	p15, 0, r10, c7, c10, 4	@ DSB   /* mem barrier to sync up things */
		mcr	p15, 0, r10, c7, c5, 0	@ invalidate I+BTB
		mcr	p15, 0, r10, c7, c10, 4	@ DSB
		mcr	p15, 0, r10, c7, c5, 4	@ ISB
/* END __armv7_mmu_cache_flush()  ***
 	*/

	ldmfd 	r13!, {r0-r12, pc}
