/* Default to a single AD5384 device:
 * (but allow it to be pre-defined)
 */
#ifndef AD5384_DEVTOT
#define AD5384_DEVTOT 1
#endif

/* 24 bits of serial data...
 */
#define BREG			0x80
#define AREG			0x00
#define READ			0x40
#define AD5384_WRITE	0x00
#define A5				0x20
#define A4				0x10
#define A3				0x08
#define A2				0x04
#define A1				0x02
#define A0				0x01

#define REG1	0x80
#define REG0	0x40
#define DB13	0x20
#define DB12	0x10
#define DB11	0x08
#define DB10	0x04
#define DB9		0x02
#define DB8		0x01

#define DB7		0x80
#define DB6		0x40
#define DB5		0x20
#define DB4		0x10
#define DB3		0x08
#define DB2		0x04
#define DB1		0x02
#define DB0		0x01

/* Register selection:
 */
#define INPUTDATA	(REG1 | REG0)
#define OFFSET		REG1
#define DACGAIN		REG0
#define SFR			0

#define DACBAUD 25000000	// 33ns min SCLK cycle time (30303030 MHz).

extern int ad5384_init(int);
extern int ad5384_writeclrcode(int,unsigned short);
extern int ad5384_softclear(int);
extern int ad5384_nop(int);
extern int ad5384_softclear(int);
extern int ad5384_softpowerdown(int);
extern int ad5384_softpowerup(int);
extern int ad5384_ctrlwrite(int, unsigned short);
extern int ad5384_ctrlread(int, unsigned char *);
extern int ad5384_monitorchannel(int);
extern int ad5384_softreset(int);
extern int ad5384_getvout(int, int, unsigned short *);
extern int ad5384_setvout(int, int, unsigned short);
extern int ad5384Cmd(int argc, char *argv[]);
extern int ad5384_decrement_vout(int, int);
