/* DRAM stuff...
 */
#define TRAS	5
#define TRP		2

/* Uart stuff...
 */
#define DEFAULT_BAUD_RATE 57600
#define THR		0x00
#define RBR		0x00
#define DLL		0x00
#define DLH		0x04
#define IER		0x04
#define LCR		0x0c
#define MCR		0x10
#define LSR		0x14
#define SCR		0x1c
#define GCTL	0x24

#define UART0_BASE		0xffc00400
#define UART1_BASE		0xffc02000
#define RS232_PORT		UART0_BASE
#define CONSOLE(reg)	(RS232_PORT+reg)

/* Port G GPIO control:
 */
#define AD5384_LDAC_N_BIT	0x0001
#define AD5384_LDAC_N_SET()	*pPORTGIO_SET = AD5384_LDAC_N_BIT
#define AD5384_LDAC_N_CLR()	*pPORTGIO_CLEAR = AD5384_LDAC_N_BIT
#define TOSA_TEC_EN_BIT		0x0002
#define TOSA_TEC_SET()		*pPORTGIO_SET = TOSA_TEC_EN_BIT
#define TOSA_TEC_CLR()		*pPORTGIO_CLEAR = TOSA_TEC_EN_BIT

extern int IFlush(char *addr);
extern int Flush(char *addr);
extern int FlushInv(char *addr);
extern int PreFetch(char *addr);

/* If for some reason, DMA-based character reception on the UARTs is
 * not desireable, then comment out this definition...
 */
#define DMA_UART_RCV

/* SPI Setup:
 * The baudrate is set to the slowest speed of all devices on
 * the SPI interface.  In our case, the only device is the ATMEL
 * flash which can run at 70Mhz.
 */
#define SPI_BAUDRATE	70000000
